## docker-buildx 0.20.1

=== Makefile ===
ifneq (, $(BUILDX_BIN))
	export BUILDX_CMD = $(BUILDX_BIN)
else ifneq (, $(shell docker buildx version))
	export BUILDX_CMD = docker buildx
else ifneq (, $(shell which buildx))
	export BUILDX_CMD = $(which buildx)
endif

export BUILDX_CMD ?= docker buildx

BAKE_TARGETS := binaries binaries-cross lint lint-gopls validate-vendor validate-docs validate-authors validate-generated-files

.PHONY: all
all: binaries

.PHONY: build
build:
	./hack/build

.PHONY: shell
shell:
	./hack/shell

.PHONY: $(BAKE_TARGETS)
$(BAKE_TARGETS):
	$(BUILDX_CMD) bake $@

.PHONY: install
install: binaries
	mkdir -p ~/.docker/cli-plugins
	install bin/build/buildx ~/.docker/cli-plugins/docker-buildx

.PHONY: release
release:
	./hack/release

.PHONY: validate-all
validate-all: lint test validate-vendor validate-docs validate-generated-files

.PHONY: test
test:
	./hack/test

.PHONY: test-unit
test-unit:
	TESTPKGS=./... SKIP_INTEGRATION_TESTS=1 ./hack/test

.PHONY: test
test-integration:
	TESTPKGS=./tests ./hack/test

.PHONY: test-driver
test-driver:
	./hack/test-driver

.PHONY: vendor
vendor:
	./hack/update-vendor

.PHONY: docs
docs:
	./hack/update-docs

.PHONY: authors
authors:
	$(BUILDX_CMD) bake update-authors

.PHONY: mod-outdated
mod-outdated:
	$(BUILDX_CMD) bake mod-outdated

.PHONY: generated-files
generated-files:
	$(BUILDX_CMD) bake update-generated-files

=== vendor/github.com/theupdateframework/notary/Makefile ===
# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

GOFLAGS := -mod=vendor

# Populate version variables
# Add to compile time flags
NOTARY_PKG := github.com/theupdateframework/notary
NOTARY_VERSION := $(shell cat NOTARY_VERSION)
GITCOMMIT := $(shell git rev-parse --short HEAD)
GITUNTRACKEDCHANGES := $(shell git status --porcelain --untracked-files=no)
ifneq ($(GITUNTRACKEDCHANGES),)
GITCOMMIT := $(GITCOMMIT)-dirty
endif
CTIMEVAR=-X $(NOTARY_PKG)/version.GitCommit=$(GITCOMMIT) -X $(NOTARY_PKG)/version.NotaryVersion=$(NOTARY_VERSION)
GO_LDFLAGS=-ldflags "-w $(CTIMEVAR)"
GO_LDFLAGS_STATIC=-ldflags "-w $(CTIMEVAR) -extldflags -static"
GOOSES = darwin linux windows
NOTARY_BUILDTAGS ?= pkcs11
NOTARYDIR := /go/src/github.com/theupdateframework/notary

# check to be sure pkcs11 lib is always imported with a build tag
GO_LIST_PKCS11 := $(shell go list -tags "${NOTARY_BUILDTAGS}" -e -f '{{join .Deps "\n"}}' ./... | grep -v /vendor/ | xargs go list -e -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | grep -q pkcs11)
ifeq ($(GO_LIST_PKCS11),)
$(info pkcs11 import was not found anywhere without a build tag, yay)
else
$(error You are importing pkcs11 somewhere and not using a build tag)
endif

_empty :=
_space := $(empty) $(empty)

# go cover test variables
COVERPROFILE?=coverage.txt
COVERMODE=atomic
PKGS ?= $(shell go list -tags "${NOTARY_BUILDTAGS}" ./... | grep -v /vendor/ | tr '\n' ' ')

.PHONY: clean all lint build test binaries cross cover docker-images notary-dockerfile
.DELETE_ON_ERROR: cover
.DEFAULT: default

all: clean lint build test binaries

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

${PREFIX}/bin/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-server

${PREFIX}/bin/notary: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary

${PREFIX}/bin/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-signer

${PREFIX}/bin/escrow: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/escrow

ifeq ($(shell uname -s),Darwin)
${PREFIX}/bin/static/notary-server:
	@echo "notary-server: static builds not supported on OS X"

${PREFIX}/bin/static/notary-signer:
	@echo "notary-signer: static builds not supported on OS X"

${PREFIX}/bin/static/notary:
	@echo "notary: static builds not supported on OS X"
else
${PREFIX}/bin/static/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@(export CGO_ENABLED=0; go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary-server)

${PREFIX}/bin/static/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@(export CGO_ENABLED=0; go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary-signer)

${PREFIX}/bin/static/notary:
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary
endif


# run all lint functionality - excludes Godep directory, vendoring, binaries, python tests, and git files
lint:
	@echo "+ $@: golint, go vet, go fmt, gocycle, misspell, ineffassign"
	# golint
	@test -z "$(shell find . -type f -name "*.go" -not -path "./vendor/*" -not -name "*.pb.*" -exec golint {} \; | tee /dev/stderr)"
	# gofmt
	@test -z "$$(gofmt -s -l .| grep -v .pb. | grep -v vendor/ | tee /dev/stderr)"
	# govet
ifeq ($(shell uname -s), Darwin)
	@test -z "$(shell find . -iname *test*.go | grep -v _test.go | grep -v vendor | xargs echo "This file should end with '_test':"  | tee /dev/stderr)"
else
	@test -z "$(shell find . -iname *test*.go | grep -v _test.go | grep -v vendor | xargs -r echo "This file should end with '_test':"  | tee /dev/stderr)"
endif
	@test -z "$$(go vet -printf=false . 2>&1 | grep -v vendor/ | tee /dev/stderr)"
	# gocyclo - we require cyclomatic complexity to be < 16
	@test -z "$(shell find . -type f -name "*.go" -not -path "./vendor/*" -not -name "*.pb.*" -exec gocyclo -over 15 {} \; | tee /dev/stderr)"
	# misspell - requires that the following be run first:
	#    go get -u github.com/client9/misspell/cmd/misspell
	@test -z "$$(find . -type f | grep -v vendor/ | grep -v bin/ | grep -v misc/ | grep -v .git/ | grep -v \.pdf | xargs misspell | tee /dev/stderr)"
	# ineffassign - requires that the following be run first:
	#    go get -u github.com/gordonklaus/ineffassign
	@test -z "$(shell find . -type f -name "*.go" -not -path "./vendor/*" -not -name "*.pb.*" -exec ineffassign {} \; | tee /dev/stderr)"
	# gosec - requires that the following be run first:
	#    go get -u github.com/securego/gosec/cmd/gosec/...
	@rm -f gosec_output.csv
	@gosec -fmt=csv -out=gosec_output.csv -exclude=G104,G304 ./... || (cat gosec_output.csv >&2; exit 1)

build:
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS}" -v ${GO_LDFLAGS} $(PKGS)

# When running `go test ./...`, it runs all the suites in parallel, which causes
# problems when running with a yubikey
test: TESTOPTS =
test:
	@echo Note: when testing with a yubikey plugged in, make sure to include 'TESTOPTS="-p 1"'
	@echo "+ $@ $(TESTOPTS)"
	@echo
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) $(PKGS)

integration: TESTDB = mysql
integration: clean
	buildscripts/integrationtest.sh $(TESTDB)

testdb: TESTDB = mysql
testdb:
	buildscripts/dbtests.sh $(TESTDB)

protos:
	@protoc --go_out=plugins=grpc:. proto/*.proto

# This allows coverage for a package to come from tests in different package.
# Requires that the following:
# go get github.com/wadey/gocovmerge; go install github.com/wadey/gocovmerge
#
# be run first
gen-cover:
gen-cover:
	@python -u buildscripts/covertest.py --tags "$(NOTARY_BUILDTAGS)" --pkgs="$(PKGS)" --testopts="${TESTOPTS}"

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
cover: gen-cover covmerge
	@go tool cover -html="$(COVERPROFILE)"

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
ci: override TESTOPTS = -race
# Codecov knows how to merge multiple coverage files, so covmerge is not needed
ci: gen-cover

yubikey-tests: override PKGS = github.com/theupdateframework/notary/cmd/notary github.com/theupdateframework/notary/trustmanager/yubikey
yubikey-tests: ci

covmerge:
	@gocovmerge $(shell find . -name coverage*.txt | tr "\n" " ") > $(COVERPROFILE)
	@go tool cover -func="$(COVERPROFILE)"

clean-protos:
	@rm proto/*.pb.go

client: ${PREFIX}/bin/notary
	@echo "+ $@"

binaries: ${PREFIX}/bin/notary-server ${PREFIX}/bin/notary ${PREFIX}/bin/notary-signer
	@echo "+ $@"

escrow: ${PREFIX}/bin/escrow
	@echo "+ $@"

static: ${PREFIX}/bin/static/notary-server ${PREFIX}/bin/static/notary-signer ${PREFIX}/bin/static/notary
	@echo "+ $@"

notary-dockerfile:
	@docker build --rm --force-rm -t notary .

server-dockerfile:
	@docker build --rm --force-rm -f server.Dockerfile -t notary-server .

signer-dockerfile:
	@docker build --rm --force-rm -f signer.Dockerfile -t notary-signer .

docker-images: notary-dockerfile server-dockerfile signer-dockerfile

shell: notary-dockerfile
	docker run --rm -it -v $(CURDIR)/cross:$(NOTARYDIR)/cross -v $(CURDIR)/bin:$(NOTARYDIR)/bin notary bash

cross:
	@rm -rf $(CURDIR)/cross
	@docker build --rm --force-rm -t notary -f cross.Dockerfile .
	docker run --rm -v $(CURDIR)/cross:$(NOTARYDIR)/cross -e CTIMEVAR="${CTIMEVAR}" -e NOTARY_BUILDTAGS=$(NOTARY_BUILDTAGS) notary buildscripts/cross.sh $(GOOSES)

clean:
	@echo "+ $@"
	@rm -rf .cover cross
	find . -name coverage.txt -delete
	@rm -rf "${PREFIX}/bin/notary-server" "${PREFIX}/bin/notary" "${PREFIX}/bin/notary-signer"
	@rm -rf "${PREFIX}/bin/static"

=== debian/changelog ===
docker-buildx (0.20.1-0ubuntu1~24.04.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Mon, 23 Jun 2025 12:28:26 +1000

docker-buildx (0.20.1-0ubuntu1~24.04.1) noble; urgency=medium

  * Backport from plucky to noble (LP: #2085187)
  * d/control: build with golang 1.22 for consistency across the supported
    release
  * d/rules: add golang 1.22 to PATH

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Wed, 26 Mar 2025 16:21:58 -0300

docker-buildx (0.20.1-0ubuntu1) plucky; urgency=medium

  * d/watch: do not watch pre releases
  * New upstream version 0.20.1
  * d/control: build with golang 1.24 (LP: #2098662)
  * d/rules: add golang 1.24 to PATH
  * d/s/lintian-overrides: remove unused overrides
  * d/docker-buildx.docs: update NOTICE file list
  * d/copyright: update copyright data
  * d/t/control: add missing B-D on file

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 17 Feb 2025 14:34:35 -0300

=== debian/control ===
Source: docker-buildx
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               golang-1.22-go
Standards-Version: 4.6.2
Homepage: https://github.com/docker/buildx
Vcs-Git: https://github.com/canonical/docker-buildx.git
Vcs-Browser: https://github.com/canonical/docker-buildx
Rules-Requires-Root: no

Package: docker-buildx
Architecture: any
Depends: docker.io,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Docker CLI plugin for extended build capabilities with BuildKit
 buildx is a Docker CLI plugin for extended build capabilities with BuildKit.
 .
 Key features:
 .
  * Familiar UI from docker build
  * Full BuildKit capabilities with container driver
  * Multiple builder instance support
  * Multi-node builds for cross-platform images
  * Compose build support
  * High-level build constructs (bake)
  * In-container driver support (both Docker and Kubernetes)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export VERSION := $(DEB_VERSION_UPSTREAM)

export BUILDX_GITCOMMIT := $(DEB_VERSION)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

# Build with Golang 1.22
export PATH := /usr/lib/go-1.22/bin:$(PATH)

override_dh_gencontrol:
	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker-buildx.substvars
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		github.com/docker/buildx/cmd/buildx \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_build:
	make \
		VERSION='$(VERSION)' \
		REVISION='$(BUILDX_GITCOMMIT)' \
		build

# Basic smoke test to ensure binary built successfully
# (especially since its actual tests, even unit tests, are *really* involved.
# They depend on docker itself which requires user's permission adjustement or
# running with root. That's just the beginning :)
# Let's smoke test the plugin via autopkgtest. FWIW this is the same thing we
# do with src:docker.io-app.
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./bin/build/docker-buildx version
endif

override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be

override_dh_dwz:
	# do not call dh_dwz to avoid "dwz: Too few files for multifile optimization"
	# dh_dwz --no-dwz-multifile also does not work :)

%:
	dh $@

=== debian/watch ===
version=4

opts=\
dversionmangle=s/[+~](debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
  https://github.com/docker/buildx/tags .*/archive/.*v(\d+(?:\.\d+)*).tar.gz

## docker-buildx 0.21.3

=== vendor/github.com/aws/smithy-go/Makefile ===
PRE_RELEASE_VERSION ?=

RELEASE_MANIFEST_FILE ?=
RELEASE_CHGLOG_DESC_FILE ?=

REPOTOOLS_VERSION ?= latest
REPOTOOLS_MODULE = github.com/awslabs/aws-go-multi-module-repository-tools
REPOTOOLS_CMD_CALCULATE_RELEASE = ${REPOTOOLS_MODULE}/cmd/calculaterelease@${REPOTOOLS_VERSION}
REPOTOOLS_CMD_CALCULATE_RELEASE_ADDITIONAL_ARGS ?=
REPOTOOLS_CMD_UPDATE_REQUIRES = ${REPOTOOLS_MODULE}/cmd/updaterequires@${REPOTOOLS_VERSION}
REPOTOOLS_CMD_UPDATE_MODULE_METADATA = ${REPOTOOLS_MODULE}/cmd/updatemodulemeta@${REPOTOOLS_VERSION}
REPOTOOLS_CMD_GENERATE_CHANGELOG = ${REPOTOOLS_MODULE}/cmd/generatechangelog@${REPOTOOLS_VERSION}
REPOTOOLS_CMD_CHANGELOG = ${REPOTOOLS_MODULE}/cmd/changelog@${REPOTOOLS_VERSION}
REPOTOOLS_CMD_TAG_RELEASE = ${REPOTOOLS_MODULE}/cmd/tagrelease@${REPOTOOLS_VERSION}
REPOTOOLS_CMD_MODULE_VERSION = ${REPOTOOLS_MODULE}/cmd/moduleversion@${REPOTOOLS_VERSION}

UNIT_TEST_TAGS=
BUILD_TAGS=

ifneq ($(PRE_RELEASE_VERSION),)
	REPOTOOLS_CMD_CALCULATE_RELEASE_ADDITIONAL_ARGS += -preview=${PRE_RELEASE_VERSION}
endif

smithy-publish-local:
	cd codegen && ./gradlew publishToMavenLocal

smithy-build:
	cd codegen && ./gradlew build

smithy-clean:
	cd codegen && ./gradlew clean

##################
# Linting/Verify #
##################
.PHONY: verify vet cover

verify: vet

vet:
	go vet ${BUILD_TAGS} --all ./...

cover:
	go test ${BUILD_TAGS} -coverprofile c.out ./...
	@cover=`go tool cover -func c.out | grep '^total:' | awk '{ print $$3+0 }'`; \
		echo "total (statements): $$cover%";

################
# Unit Testing #
################
.PHONY: unit unit-race unit-test unit-race-test

unit: verify
	go vet ${BUILD_TAGS} --all ./... && \
	go test ${BUILD_TAGS} ${RUN_NONE} ./... && \
	go test -timeout=1m ${UNIT_TEST_TAGS} ./...

unit-race: verify
	go vet ${BUILD_TAGS} --all ./... && \
	go test ${BUILD_TAGS} ${RUN_NONE} ./... && \
	go test -timeout=1m ${UNIT_TEST_TAGS} -race -cpu=4 ./...

unit-test: verify
	go test -timeout=1m ${UNIT_TEST_TAGS} ./...

unit-race-test: verify
	go test -timeout=1m ${UNIT_TEST_TAGS} -race -cpu=4 ./...

#####################
#  Release Process  #
#####################
.PHONY: preview-release pre-release-validation release

preview-release:
	go run ${REPOTOOLS_CMD_CALCULATE_RELEASE} ${REPOTOOLS_CMD_CALCULATE_RELEASE_ADDITIONAL_ARGS}

pre-release-validation:
	@if [[ -z "${RELEASE_MANIFEST_FILE}" ]]; then \
		echo "RELEASE_MANIFEST_FILE is required to specify the file to write the release manifest" && false; \
	fi
	@if [[ -z "${RELEASE_CHGLOG_DESC_FILE}" ]]; then \
		echo "RELEASE_CHGLOG_DESC_FILE is required to specify the file to write the release notes" && false; \
	fi

release: pre-release-validation
	go run ${REPOTOOLS_CMD_CALCULATE_RELEASE} -o ${RELEASE_MANIFEST_FILE} ${REPOTOOLS_CMD_CALCULATE_RELEASE_ADDITIONAL_ARGS}
	go run ${REPOTOOLS_CMD_UPDATE_REQUIRES} -release ${RELEASE_MANIFEST_FILE}
	go run ${REPOTOOLS_CMD_UPDATE_MODULE_METADATA} -release ${RELEASE_MANIFEST_FILE}
	go run ${REPOTOOLS_CMD_GENERATE_CHANGELOG} -release ${RELEASE_MANIFEST_FILE} -o ${RELEASE_CHGLOG_DESC_FILE}
	go run ${REPOTOOLS_CMD_CHANGELOG} rm -all
	go run ${REPOTOOLS_CMD_TAG_RELEASE} -release ${RELEASE_MANIFEST_FILE}

module-version:
	@go run ${REPOTOOLS_CMD_MODULE_VERSION} .

##############
# Repo Tools #
##############
.PHONY: install-changelog

install-changelog:
	go install ${REPOTOOLS_MODULE}/cmd/changelog@${REPOTOOLS_VERSION}

=== vendor/github.com/containerd/continuity/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

PKG=github.com/containerd/continuity

PACKAGES=$(shell go list -mod=vendor ./... | grep -v /vendor/)
TEST_REQUIRES_ROOT_PACKAGES=$(filter \
    ${PACKAGES}, \
    $(shell \
    for f in $$(git grep -l testutil.RequiresRoot | grep -v Makefile); do \
        d="$$(dirname $$f)"; \
        [ "$$d" = "." ] && echo "${PKG}" && continue; \
        echo "${PKG}/$$d"; \
    done | sort -u) \
    )

.PHONY: clean all lint build test binaries
.DEFAULT: default

all: AUTHORS clean lint build test binaries

AUTHORS: .mailmap .git/HEAD
	 git log --format='%aN <%aE>' | sort -fu > $@

${PREFIX}/bin/continuity:
	@echo "+ $@"
	@(cd cmd/continuity && go build -mod=mod -o $@  ${GO_GCFLAGS} .)

generate:
	go generate -mod=vendor $(PACKAGES)

lint:
	@echo "+ $@"
	@golangci-lint run
	@(cd cmd/continuity && golangci-lint --config=../../.golangci.yml run)

build:
	@echo "+ $@"
	@go build -mod=vendor -v ${GO_LDFLAGS} $(PACKAGES)

test:
	@echo "+ $@"
	@go test -mod=vendor $(PACKAGES)

root-test:
	@echo "+ $@"
	@go test -exec sudo ${TEST_REQUIRES_ROOT_PACKAGES} -test.root -test.v

test-compile:
	@echo "+ $@"
	@for pkg in $(PACKAGES); do go test -mod=vendor -c $$pkg; done

binaries: ${PREFIX}/bin/continuity
	@echo "+ $@"
	@if [ x$$GOOS = xwindows ]; then echo "+ continuity -> continuity.exe"; mv ${PREFIX}/bin/continuity ${PREFIX}/bin/continuity.exe; fi

clean:
	@echo "+ $@"
	@rm -rf "${PREFIX}/bin/continuity" "${PREFIX}/bin/continuity.exe"

=== vendor/github.com/Masterminds/semver/v3/Makefile ===
GOPATH=$(shell go env GOPATH)
GOLANGCI_LINT=$(GOPATH)/bin/golangci-lint

.PHONY: lint
lint: $(GOLANGCI_LINT)
	@echo "==> Linting codebase"
	@$(GOLANGCI_LINT) run

.PHONY: test
test:
	@echo "==> Running tests"
	GO111MODULE=on go test -v

.PHONY: test-cover
test-cover:
	@echo "==> Running Tests with coverage"
	GO111MODULE=on go test -cover .

.PHONY: fuzz
fuzz:
	@echo "==> Running Fuzz Tests"
	go test -fuzz=FuzzNewVersion -fuzztime=15s .
	go test -fuzz=FuzzStrictNewVersion -fuzztime=15s .
	go test -fuzz=FuzzNewConstraint -fuzztime=15s .

$(GOLANGCI_LINT):
	# Install golangci-lint. The configuration for it is in the .golangci.yml
	# file in the root of the repository
	echo ${GOPATH}
	curl -sfL https://install.goreleaser.com/github.com/golangci/golangci-lint.sh | sh -s -- -b $(GOPATH)/bin v1.17.1

=== debian/changelog ===
docker-buildx (0.21.3-0ubuntu1~22.04.1) jammy; urgency=medium

  * Backport from questing to jammy (LP: #2112523)
  * d/control: build with golang 1.23
  * d/rules: add golang 1.23 to PATH

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Wed, 10 Sep 2025 16:59:48 -0300

docker-buildx (0.21.3-0ubuntu1) questing; urgency=medium

  * d/watch: fetch releases data from the Github API. This allows us to fetch
    more available versions
  * New upstream version 0.21.3:
    - CVE-2025-0495

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Thu, 03 Jul 2025 10:30:29 -0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
-               golang-1.22-go
+               golang-1.23-go
 Standards-Version: 4.6.2
 Homepage: https://github.com/docker/buildx
 Vcs-Git: https://github.com/canonical/docker-buildx.git

=== debian/rules ===
--- 
+++ 
@@ -15,8 +15,8 @@
 # https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
 export GO111MODULE := auto
 
-# Build with Golang 1.22
-export PATH := /usr/lib/go-1.22/bin:$(PATH)
+# Build with Golang 1.23
+export PATH := /usr/lib/go-1.23/bin:$(PATH)
 
 override_dh_gencontrol:
 	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker-buildx.substvars

=== debian/watch ===
version=4

opts=\
searchmode=plain,\
dversionmangle=s/[+~](debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
  https://api.github.com/repos/docker/buildx/tags?per_page=50 \
  https://api.github.com/repos/docker/buildx/tarball/refs/tags/[vV]?((?:\d+\.)*\d+)

## docker-buildx 0.26.1

=== debian/changelog ===
docker-buildx (0.26.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 0.26.1 release
  * Update the quilt patch
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 03 Aug 2025 17:10:06 +0200

docker-buildx (0.19.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 0.19.3 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 15 Jan 2025 15:36:14 +0200

docker-buildx (0.18.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 0.18.0 release
  * Update the quilt patch
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 19 Nov 2024 01:54:06 +0200

docker-buildx (0.16.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 0.16.2 release
  * Update the quilt patch
  * Bump the Standards-Version
  * Bump the golang-go version required to build
  * Remove the i386 arch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 15 Aug 2024 15:02:32 +0200

docker-buildx (0.14.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 0.14.0 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 25 Apr 2024 19:34:09 +0200

docker-buildx (0.12.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 0.12.1 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 12 Feb 2024 23:01:17 +0200

docker-buildx (0.11.2-2kaisen) kaisen-packages; urgency=medium

  * Remove golang-go as package dependancy

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 07 Aug 2023 13:28:58 +0200

docker-buildx (0.11.2-1kaisen) kaisen-packages; urgency=medium

  * Initial release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 03 Aug 2023 14:38:03 +0200

=== debian/control ===
Source: docker-buildx
Section: admin
Priority: optional
Maintainer: Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 golang-go (>= 1.23),
 dh-golang,
Standards-Version: 4.7.2
Homepage: https://github.com/docker/buildx/
Vcs-Browser: https://gitlab.com/kaisenlinux/packages/buildx
Vcs-Git: https://gitlab.com/kaisenlinux/packages/buildx.git

Package: docker-buildx
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Docker CLI plugin for extended build capabilities with BuildKit

=== debian/rules ===
#!/usr/bin/make -f

export GOPATH=$(CURDIR)/_build

%:
	dh $@ --buildsystem=golang --builddirectory=_build

override_dh_auto_clean:
	rm -rf $(CURDIR)/_build

override_dh_auto_build:
	make build

override_dh_auto_test:

override_dh_dwz:

override_dh_auto_install:
	install -p -m 0755 $(CURDIR)/bin/build/docker-buildx $(CURDIR)/debian/docker-buildx/usr/libexec/docker/cli-plugins

## docker-buildx 0.29.1+ds1

=== debian/changelog ===
docker-buildx (0.29.1+ds1-1) experimental; urgency=medium

  [ Nicolas Peugnet ]
  * New upstream version 0.29.1+ds1
  * Rediff patches
  * Update dependencies based on dh-make-golang check-depends
  * Disable history trace command due to missing dependency
  * Add new test directory to build
  * Skip one test that depends on golang-opentelemetry-otel-dev >= 1.32
  * Avoid k8s-sigs-structured-merge-diff from experimental
  * Require the latest repack of docker-dev
  * Update copyright information
  * Bump Standards-Version to 4.7.3, drop Rules-Requires-Root & Priority fieds

  [ Moritz Schlarb ]
  * Add Conflicts: docker-buildx-plugin (Closes: #1120500)

  [ Reinhard Tartler ]
  * Add Build-Conflicts on golang-google-grpc-dev in experimental

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 04 Mar 2026 06:13:58 -0500

=== debian/control ===
Source: docker-buildx
Section: golang
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Nicolas Peugnet <nicolas@club1.fr>,
           Reinhard Tartler <siretart@tauware.de>,
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-golang,
               git <!nocheck>,
               golang-any,
               golang-github-aws-aws-sdk-go-v2-dev,
               golang-github-compose-spec-compose-go-dev (>= 2.9),
               golang-github-containerd-console-dev,
               golang-github-containerd-containerd-dev (>= 2),
               golang-github-containerd-continuity-dev,
               golang-github-containerd-errdefs-dev,
               golang-github-containerd-log-dev,
               golang-github-containerd-platforms-dev,
               golang-github-containerd-typeurl-dev,
               golang-github-creack-pty-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-distribution-reference-dev,
               golang-github-docker-cli-docs-tool-dev,
               golang-github-docker-docker-dev (>= 28.5.2+dfsg2),
               golang-github-docker-go-units-dev,
               golang-github-gofrs-flock-dev,
               golang-github-google-go-dap-dev (>= 0.12.0),
               golang-github-google-shlex-dev,
               golang-github-google-uuid-dev,
               golang-github-hashicorp-go-cty-funcs-dev,
               golang-github-hashicorp-go-multierror-dev,
               golang-github-hashicorp-hcl-v2-dev,
               golang-github-in-toto-in-toto-golang-dev,
               golang-github-masterminds-semver-dev,
               golang-github-mitchellh-hashstructure-dev,
               golang-github-moby-go-archive-dev,
               golang-github-moby-sys-dev,
               golang-github-morikuni-aec-dev,
               golang-github-opencontainers-go-digest-dev,
               golang-github-opencontainers-image-spec-dev,
               golang-github-pelletier-go-toml-dev,
               golang-github-pkg-browser-dev,
               golang-github-pkg-errors-dev,
               golang-github-serialx-hashring-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tonistiigi-fsutil-dev (>= 0.0~git20251211.a2aa163),
               golang-github-zclconf-go-cty-dev,
               golang-golang-x-mod-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-term-dev,
               golang-golang-x-text-dev,
               golang-google-grpc-dev,
               golang-google-protobuf-dev,
               golang-gopkg-yaml.v3-dev,
               golang-k8s-api-dev,
               golang-k8s-apimachinery-dev,
               golang-k8s-apiserver-dev,
               golang-k8s-client-go-dev,
               golang-logrus-dev,
               golang-opentelemetry-otel-dev,
Build-Conflicts: golang-github-cenkalti-backoff-dev (>> 5),
                 golang-k8s-sigs-structured-merge-diff-dev (>> 5),
                 golang-google-grpc-dev (>> 1.66.99)
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/docker-buildx
Vcs-Git: https://salsa.debian.org/go-team/packages/docker-buildx.git
Homepage: https://github.com/docker/buildx
XS-Go-Import-Path: github.com/docker/buildx

Package: golang-github-docker-buildx-dev
Architecture: all
Multi-Arch: foreign
Depends: golang-github-aws-aws-sdk-go-v2-dev,
         golang-github-compose-spec-compose-go-dev (>= 2.9),
         golang-github-containerd-console-dev,
         golang-github-containerd-containerd-dev (>= 2),
         golang-github-containerd-continuity-dev,
         golang-github-containerd-errdefs-dev,
         golang-github-containerd-log-dev,
         golang-github-containerd-platforms-dev,
         golang-github-containerd-typeurl-dev,
         golang-github-creack-pty-dev,
         golang-github-davecgh-go-spew-dev,
         golang-github-distribution-reference-dev,
         golang-github-docker-cli-docs-tool-dev,
         golang-github-docker-docker-dev (>= 28.5.2+dfsg2),
         golang-github-docker-go-units-dev,
         golang-github-gofrs-flock-dev,
         golang-github-google-go-dap-dev (>= 0.12.0),
         golang-github-google-shlex-dev,
         golang-github-google-uuid-dev,
         golang-github-hashicorp-go-cty-funcs-dev,
         golang-github-hashicorp-go-multierror-dev,
         golang-github-hashicorp-hcl-v2-dev,
         golang-github-in-toto-in-toto-golang-dev,
         golang-github-masterminds-semver-dev,
         golang-github-mitchellh-hashstructure-dev,
         golang-github-moby-go-archive-dev,
         golang-github-moby-sys-dev,
         golang-github-morikuni-aec-dev,
         golang-github-opencontainers-go-digest-dev,
         golang-github-opencontainers-image-spec-dev,
         golang-github-pelletier-go-toml-dev,
         golang-github-pkg-browser-dev,
         golang-github-pkg-errors-dev,
         golang-github-serialx-hashring-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-stretchr-testify-dev,
         golang-github-tonistiigi-fsutil-dev (>= 0.0~git20251211.a2aa163),
         golang-github-zclconf-go-cty-dev,
         golang-golang-x-mod-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-term-dev,
         golang-golang-x-text-dev,
         golang-google-grpc-dev,
         golang-google-protobuf-dev,
         golang-gopkg-yaml.v3-dev,
         golang-k8s-api-dev,
         golang-k8s-apimachinery-dev,
         golang-k8s-apiserver-dev,
         golang-k8s-client-go-dev,
         golang-logrus-dev,
         golang-opentelemetry-otel-dev,
         ${misc:Depends},
Description: Docker CLI plugin for extended build capabilities with BuildKit (library)
 This package contains the sources of docker-buildx, to be used with
 packages that depend on it.

Package: docker-buildx
Section: admin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: docker-cli,
Conflicts: docker-buildx-plugin,
Static-Built-Using: ${misc:Static-Built-Using}
Description: Docker CLI plugin for extended build capabilities with BuildKit (program)
 buildx is a Docker CLI plugin for extended build capabilities with
 BuildKit (https://github.com/moby/buildkit).
 .
 Key features:
 .
  * Familiar UI from docker build
  * Full BuildKit capabilities with container driver
  * Multiple builder instance support
  * Multi-node builds for cross-platform images
  * Compose build support
  * High-level build constructs (bake)
  * In-container driver support (both Docker and Kubernetes)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOPKG := github.com/docker/buildx
LDFLAGS := -X $(DH_GOPKG)/version.Version=$(DEB_VERSION_UPSTREAM)
LDFLAGS += -X $(DH_GOPKG)/version.Revision=$(DEB_VERSION)
LDFLAGS += -X $(DH_GOPKG)/version.Package=$(DH_GOPKG)

export DH_GOLANG_INSTALL_EXTRA := driver/kubernetes/context/fixtures util/otelutil/fixtures

# The integration tests depend on a "registry" binary, unavailable in Debian
export SKIP_INTEGRATION_TESTS=1

%:
	dh $@ --builddirectory=_build --buildsystem=golang

override_dh_auto_build:
	dh_auto_build --builddirectory=_build --buildsystem=golang -- -ldflags '$(LDFLAGS)'
	# Generate the manual pages
	_build/bin/docs --formats=man --source=docs/reference

# Install binaries manually, using the install file, as the executable need to
# be in a specific directory.
override_dh_auto_install:
	dh_auto_install -- --no-binaries

# Required for dh-golang-autopkgtest as a directory named "build" exists in
# the sources.
build: .FORCE

.PHONY: .FORCE
.FORCE:

## docker-buildx 0.30.1

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 export BUILDX_CMD ?= docker buildx
 
-BAKE_TARGETS := binaries binaries-cross lint lint-gopls validate-vendor validate-docs validate-authors validate-generated-files
+BAKE_TARGETS := binaries binaries-cross lint lint-gopls validate-vendor validate-docs validate-authors
 
 .PHONY: all
 all: binaries
@@ -35,7 +35,7 @@
 	./hack/release
 
 .PHONY: validate-all
-validate-all: lint test validate-vendor validate-docs validate-generated-files
+validate-all: lint test validate-vendor validate-docs
 
 .PHONY: test
 test:
@@ -45,7 +45,7 @@
 test-unit:
 	TESTPKGS=./... SKIP_INTEGRATION_TESTS=1 ./hack/test
 
-.PHONY: test
+.PHONY: test-integration
 test-integration:
 	TESTPKGS=./tests ./hack/test
 
@@ -68,7 +68,3 @@
 .PHONY: mod-outdated
 mod-outdated:
 	$(BUILDX_CMD) bake mod-outdated
-
-.PHONY: generated-files
-generated-files:
-	$(BUILDX_CMD) bake update-generated-files

=== debian/changelog ===
docker-buildx (0.30.1-0ubuntu1) resolute; urgency=medium

  * New upstream version 0.30.1
  * d/docker-buildx.docs: update NOTICE files
  * d/s/lintian-overrides: ignore vendored code long lines
  * d/copyright: update copyright data

 -- Athos Ribeiro <athos@ubuntu.com>  Tue, 16 Dec 2025 12:03:00 -0300
